Imports System

Module Program
    Private Delegate Sub delegates()

    Sub Main()
        Dim list = New SortedArrayList(Of Integer)()
        Dim funcs As delegates() = New delegates() {
            New delegates(AddressOf list.BubbleSort),
            New delegates(AddressOf list.InsertionSort),
            New delegates(AddressOf list.QuickSort),
            New delegates(AddressOf list.MergeSortParallel),
            New delegates(AddressOf list.MergeSort),
            New delegates(AddressOf list.BucketSort)}

        Dim w = New Stopwatch()

        For Each func As delegates In funcs
            list.Add(8)
            list.Add(7)
            list.Add(3)
            list.Add(5)
            list.Add(9)
            list.Add(4)
            list.Add(1)

            w.Restart()
            func()
            w.Stop()

            Console.WriteLine(func.Method.ToString() + ": " + list.ToString())
            Console.WriteLine(w.ElapsedTicks)
            list.Clear()
        Next
        Console.ReadLine()
    End Sub
End Module
